require 'choice/option'
require 'choice/parser'
require 'choice/lazyhash'

class ParameterParser
  attr_accessor :options
  
  def initialize
    @options = []
  end
  
  def option(opt, options = {}, &block)
    @options << [opt.to_s, Choice::Option.new(options, &block)]
  end
  
  def parse(args)
    Choice::LazyHash.new(Choice::Parser.parse(@options, args))
  end  
end
