require 'ws/ebi/fetch_mapping.rb'
require 'soap/rpc/driver'

module DatabaseClient::SOAP::EBI::Fetch

class Driver < ::SOAP::RPC::Driver
  DefaultEndpointUrl = "http://www.ebi.ac.uk/ws/services/WSDbfetch"
  NsJdbfetch = "http://wsdbfetch.ws.jdbfetch.ebi.ac.uk"

  Methods = [
    [ XSD::QName.new(NsJdbfetch, "fetchData"),
      "",
      "fetchData",
      [ ["in", "query", ["::SOAP::SOAPString"]],
        ["in", "format", ["::SOAP::SOAPString"]],
        ["in", "style", ["::SOAP::SOAPString"]],
        ["retval", "fetchDataReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {"DatabaseClient::SOAP::EBI::Fetch::DbfParamsException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfParamsException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::DbfNoEntryFoundException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfNoEntryFoundException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::DbfException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::InputException"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"InputException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::DbfConnException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfConnException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}} }
    ],
    [ XSD::QName.new(NsJdbfetch, "fetchBatch"),
      "",
      "fetchBatch",
      [ ["in", "db", ["::SOAP::SOAPString"]],
        ["in", "ids", ["::SOAP::SOAPString"]],
        ["in", "format", ["::SOAP::SOAPString"]],
        ["in", "style", ["::SOAP::SOAPString"]],
        ["retval", "fetchBatchReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {"DatabaseClient::SOAP::EBI::Fetch::DbfParamsException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfParamsException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::DbfNoEntryFoundException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfNoEntryFoundException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::DbfException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::InputException"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"InputException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}, "DatabaseClient::SOAP::EBI::Fetch::DbfConnException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfConnException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}} }
    ],
    [ XSD::QName.new(NsJdbfetch, "getSupportedDBs"),
      "",
      "getSupportedDBs",
      [ ["retval", "getSupportedDBsReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {} }
    ],
    [ XSD::QName.new(NsJdbfetch, "getSupportedFormats"),
      "",
      "getSupportedFormats",
      [ ["retval", "getSupportedFormatsReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {} }
    ],
    [ XSD::QName.new(NsJdbfetch, "getDbFormats"),
      "",
      "getDbFormats",
      [ ["in", "db", ["::SOAP::SOAPString"]],
        ["retval", "getDbFormatsReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {"DatabaseClient::SOAP::EBI::Fetch::DbfParamsException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfParamsException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}} }
    ],
    [ XSD::QName.new(NsJdbfetch, "getFormatStyles"),
      "",
      "getFormatStyles",
      [ ["in", "db", ["::SOAP::SOAPString"]],
        ["in", "format", ["::SOAP::SOAPString"]],
        ["retval", "getFormatStylesReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {"DatabaseClient::SOAP::EBI::Fetch::DbfParamsException_"=>{:ns=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :namespace=>"http://www.ebi.ac.uk/ws/services/WSDbfetch", :name=>"DbfParamsException", :encodingstyle=>"http://schemas.xmlsoap.org/soap/encoding/", :use=>"encoded"}} }
    ],
    [ XSD::QName.new(NsJdbfetch, "getSupportedStyles"),
      "",
      "getSupportedStyles",
      [ ["retval", "getSupportedStylesReturn", ["DatabaseClient::SOAP::EBI::Fetch::ArrayOf_xsd_string", "http://www.ebi.ac.uk/ws/services/WSDbfetch", "ArrayOf_xsd_string"]] ],
      { :request_style =>  :rpc, :request_use =>  :encoded,
        :response_style => :rpc, :response_use => :encoded,
        :faults => {} }
    ]
  ]

  def initialize(endpoint_url = nil)
    endpoint_url ||= DefaultEndpointUrl
    super(endpoint_url, nil)
    self.mapping_registry = Mapping::EncodedRegistry
    self.literal_mapping_registry = Mapping::LiteralRegistry
    init_methods
  end

private

  def init_methods
    Methods.each do |definitions|
      opt = definitions.last
      if opt[:request_style] == :document
        add_document_operation(*definitions)
      else
        add_rpc_operation(*definitions)
        qname = definitions[0]
        name = definitions[2]
        if qname.name != name and qname.name.capitalize == name.capitalize
          ::SOAP::Mapping.define_singleton_method(self, qname.name) do |*arg|
            __send__(name, *arg)
          end
        end
      end
    end
  end
end


end
